#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <windows.h>

// Include important header files needed to interface with Outpost 2
#include "..\Outpost2DLL\Outpost2DLL.h"
// Include header files to make it easier to build levels
#include "..\OP2Helper\OP2Helper.h"
#include "..\API\IUnit\IUnit.h"
#include "..\API\IUnit\commands.h"



// Note: These exports are required by Outpost2.exe from every level
//		 DLL. They give values for the map and tech trees used by the
//		 level and a description to place in the level listbox. The
//		 last export is used to define characteristics of the level.
//		 See RequiredExports.h for more details.
//		 ** Be sure to set these when you build your own level**

char MapName[]			= "on4_01.map";							// The .map file used for this level
char LevelDesc[]  = "Test";// Description appearing in the game list box
char TechtreeName[]  = "MULTITEK.TXT";      // File to use for the tech tree
SDescBlock DescBlock = { Colony, 2, 12, 0 }; // Important level details



// Note: This is the DLL entry point which is called by Windows when the
//		 DLL is first loaded into a processes address space or unloaded
//		 from the process address space. This function also be called for
//		 each thread owned by the process, but this has been disabled
//		 for efficiency reasons by the DisableThreadLibraryCalls during
//		 the first time the method is run.
// Note: You most likely do NOT need to edit this and unless you really
//		 know what you're doing you probably shouldn't.

BOOL APIENTRY DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH) 
	{
		DisableThreadLibraryCalls(hinstDLL);
	}

    return TRUE;
}

// Note: The following function is called once by Outpost2.exe when the
//		 level is first initialized. This is where you want to create
//		 all the initial units and structures as well as setup any 
//		 map/level environment settings such as day and night.


FightGroup BaseDefense;
BuildingGroup Construction;
BuildingGroup RebuildMines;
int MiningGroupEstablished = 0;
IUnit CommonOreSmelter;
IUnit CommonOreMine;
BuildingGroup Reinforce;
MiningGroup CommonMining;
MiningGroup CommonMining2;
MAP_RECT RareBox1(69+31, 51-1, 73+31, 55-1);
IUnit VFactory;
Unit x;
Unit COSmelter;
Unit COMine;
Unit COTruck1;
Unit COTruck2;
Unit COTruck3;
Unit Convec1;
Unit Convec2;
Unit Convec3;
IUnit SFactory;
IUnit SFactory2;
Unit Miner;
Unit ROSmelter;
Unit ROTruck1;
Unit ROTruck2;
Unit ROTruck3;
Unit ROMine;
Unit FightUnit;

int InitProc()
{

Player[1].GoEden();
Player[1].SetTechLevel(12);
Player[0].SetTechLevel(12);
Player[1].SetOre(2000);
Player[1].GoAI();

CommonMining = CreateMiningGroup(Player[1]);
// Base
TethysGame::CreateUnit(x, mapCommandCenter, LOCATION(64+31, 64-1), 1, mapNone, 0);
TethysGame::CreateUnit(SFactory, mapStructureFactory, LOCATION(69+31, 64-1), 1, mapNone, 0);
TethysGame::CreateUnit(x, mapAgridome, LOCATION(69+31, 61-1), 1, mapNone, 0);
TethysGame::CreateUnit(x, mapSolarPowerArray, LOCATION(76+31, 53-1), 1, mapNone, 0);
Player[1].SetSolarSat(1);
TethysGame::CreateUnit(CommonOreSmelter, mapCommonOreSmelter, LOCATION(65+31, 60-1), 1, mapNone, 0);
TethysGame::CreateBeacon(mapMiningBeacon, 60+31, 61-1, 0, 0, 2);
TethysGame::CreateBeacon(mapFumarole,  60+31,  59-1, -1, -1, -1);
TethysGame::CreateUnit(VFactory, mapVehicleFactory, LOCATION(74+31, 61-1), 1, mapNone, 0);
TethysGame::CreateUnit(SFactory2, mapStructureFactory, LOCATION(64+31, 67-1), 1, mapNone, 0);

// Rare Ore
TethysGame::CreateUnit(ROSmelter, mapRareOreSmelter, LOCATION(74+31, 57-1), 1, mapNone, 0);
TethysGame::CreateBeacon(mapMiningBeacon, 70+31, 57-1, 1, 0, 2);
TethysGame::CreateUnit(ROMine, mapCommonOreMine, LOCATION(70+31, 57-1), 1, mapNone, 0);
TethysGame::CreateUnit(ROTruck1, mapCargoTruck, LOCATION(68+31, 67-1), 1, mapNone, 0);
ROTruck1.DoSetLights(1);
TethysGame::CreateUnit(ROTruck2, mapCargoTruck, LOCATION(64+31, 68-1), 1, mapNone, 0);
ROTruck2.DoSetLights(1);
TethysGame::CreateUnit(ROTruck3, mapCargoTruck, LOCATION(65+31, 68-1), 1, mapNone, 0);
ROTruck3.DoSetLights(1);

CommonMining2 = CreateMiningGroup(Player[1]);
CommonMining2.Setup(ROMine, ROSmelter, RareBox1);
CommonMining2.TakeUnit(ROTruck1);
CommonMining2.TakeUnit(ROTruck2);
CommonMining2.TakeUnit(ROTruck3);
CommonMining2.SetTargCount(mapCargoTruck, mapNone, 3);



// Units
TethysGame::CreateUnit(Miner, mapRoboMiner, LOCATION(64+31, 67-1), 1, mapNone, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapRoboSurveyor, LOCATION(65+31, 67-1), 1, mapNone, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapEarthworker, LOCATION(66+31, 67-1), 1, mapNone, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapRoboDozer, LOCATION(67+31, 67-1), 1, mapNone, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(COTruck1, mapCargoTruck, LOCATION(68+31, 67-1), 1, mapNone, 0);
COTruck1.DoSetLights(1);
TethysGame::CreateUnit(COTruck2, mapCargoTruck, LOCATION(64+31, 68-1), 1, mapNone, 0);
COTruck2.DoSetLights(1);
TethysGame::CreateUnit(COTruck3, mapCargoTruck, LOCATION(65+31, 68-1), 1, mapNone, 0);
COTruck3.DoSetLights(1);
TethysGame::CreateUnit(Convec1, mapConVec, LOCATION(66+31, 68-1), 1, mapNone, 0);
Convec1.DoSetLights(1);
TethysGame::CreateUnit(Convec2, mapConVec, LOCATION(67+31, 68-1), 1, mapNone, 0);
Convec2.DoSetLights(1);
TethysGame::CreateUnit(Convec3, mapConVec, LOCATION(68+31, 68-1), 1, mapNone, 0);
Convec3.DoSetLights(1);




TethysGame::SetDaylightEverywhere(0);




// BuildingGroup
Construction = CreateBuildingGroup(Player[1]);
MAP_RECT ConVecBox(67+31, 66-1, 71+31, 70-1);
Construction.SetRect(ConVecBox);
Construction.TakeUnit(SFactory);
Construction.TakeUnit(SFactory2);
Construction.TakeUnit(Convec1);
Construction.TakeUnit(Convec1);
Construction.TakeUnit(Convec1);
Construction.TakeUnit(VFactory);
Construction.SetTargCount(mapConVec, mapNone, 3);
Construction.SetTargCount(mapGeoCon, mapNone, 1);

Construction.RecordBuilding(LOCATION(72+31, 64-1), mapGuardPost, mapEMP);

Construction.RecordBuilding(LOCATION(60+31,  59-1), mapGeothermalPlant, mapNone);
Construction.RecordBuilding(LOCATION(69+31, 61-1), mapAgridome, mapNone);
Construction.RecordBuilding(LOCATION(61+31, 64-1), mapCommonStorage, mapNone);
Construction.RecordBuilding(LOCATION(65+31, 60-1), mapCommonOreSmelter, mapNone);
Construction.RecordBuilding(LOCATION(74+31, 61-1), mapVehicleFactory, mapNone);
Construction.RecordBuilding(LOCATION(69+31, 64-1), mapStructureFactory, mapNone);
Construction.RecordBuilding(LOCATION(64+31, 67-1), mapStructureFactory, mapNone);
// Rebuildmines
RebuildMines = CreateBuildingGroup(Player[1]);
MAP_RECT MinerBox(63+31, 54-1, 67+31, 58-1);
RebuildMines.SetRect(MinerBox);
RebuildMines.TakeUnit(Miner);
RebuildMines.SetTargCount(mapRoboMiner, mapNone, 1);
RebuildMines.SetTargCount(mapCommonOreMine, mapNone, 1);

RebuildMines.RecordBuilding(LOCATION(61+31, 61-1), mapCommonOreMine, mapNone);

// Reinforcement
Reinforce = CreateBuildingGroup(Player[1]);
Reinforce.TakeUnit(VFactory);


Reinforce.RecordVehReinforceGroup(Construction, 500);
Reinforce.RecordVehReinforceGroup(RebuildMines, 2500);
Reinforce.RecordVehReinforceGroup(CommonMining, 3000);
Reinforce.RecordVehReinforceGroup(CommonMining2, 3000);


// Player 0 units (Starflares)
TethysGame::CreateUnit(x, mapLynx, LOCATION(69+31, 59-1), 0, mapStarflare, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapLynx, LOCATION(70+31, 59-1), 0, mapStarflare, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapLynx, LOCATION(71+31, 59-1), 0, mapStarflare, 0);
x.DoSetLights(1);

TethysGame::CreateUnit(x, mapLynx, LOCATION(69+31, 58-1), 0, mapStarflare, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapLynx, LOCATION(70+31, 58-1), 0, mapStarflare, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapLynx, LOCATION(71+31, 58-1), 0, mapStarflare, 0);
x.DoSetLights(1);

TethysGame::CreateUnit(x, mapLynx, LOCATION(69+31, 57-1), 0, mapStarflare, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapLynx, LOCATION(70+31, 57-1), 0, mapStarflare, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapLynx, LOCATION(71+31, 57-1), 0, mapStarflare, 0);
x.DoSetLights(1);

TethysGame::CreateUnit(x, mapLynx, LOCATION(69+31, 56-1), 0, mapStarflare, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapLynx, LOCATION(70+31, 56-1), 0, mapStarflare, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapLynx, LOCATION(71+31, 56-1), 0, mapStarflare, 0);
x.DoSetLights(1);

// fightgroups
BaseDefense = CreateFightGroup(Player[1]);
MAP_RECT DefBox(43+31, 71-1, 54+31, 80-1);
BaseDefense.SetRect(DefBox); 

TethysGame::CreateUnit(FightUnit, mapLynx, LOCATION(50+31, 73-1), 1, mapLaser, 0);
FightUnit.DoSetLights(1);
BaseDefense.TakeUnit(FightUnit);

TethysGame::CreateUnit(FightUnit, mapLynx, LOCATION(51+31, 73-1), 1, mapLaser, 0);
FightUnit.DoSetLights(1);
BaseDefense.TakeUnit(FightUnit);

TethysGame::CreateUnit(FightUnit, mapLynx, LOCATION(50+31, 74-1), 1, mapLaser, 0);
FightUnit.DoSetLights(1);
BaseDefense.TakeUnit(FightUnit);

BaseDefense.SetTargCount(mapLynx, mapLaser, 3);
Reinforce.RecordVehReinforceGroup(BaseDefense, 5000);

//BaseDefense.DoGuardRect();


TethysGame::CreateUnit(x, mapLynx, LOCATION(30+31, 85-1), 0, mapThorsHammer, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapLynx, LOCATION(31+31, 85-1), 0, mapThorsHammer, 0);
x.DoSetLights(1);
TethysGame::CreateUnit(x, mapLynx, LOCATION(30+31, 86-1), 0, mapThorsHammer, 0);
x.DoSetLights(1);



CreateTimeTrigger(1, 0, 10000, "Repairallaibuildings");

return 1; // return 1 if OK; 0 on failure
}


// Note: The following function seems to be intended for use in
//		 controlling an AI. It is called once every game cycle. 
//		 Use it for whatever code needs to run on a continual basis.
// Note: The standard level DLLs released by Sierra leave this function
//		 empty and handle all AI controls through triggers.

void AIProc() 
{
    //Find the vecfac if it was rebuilt
    if(VFactory.IsLive() == 0)//If the handel is dead, then we need to find the new one
    {
IUnit NewVFactory;
    	InRectEnumerator Rectenum(MAP_RECT(71+31, 58-1, 77+31, 64-1));
		//It's at 74+31, 61-1
    	//Search the area near the vecfac for a new one
   	    if(Rectenum.GetNext(NewVFactory) == 1)
   	    {
            if(NewVFactory.GetType() == mapVehicleFactory)
            {
            	switch(NewVFactory.GetBusy())
                {
                    case ctMoDevelop:
                    case ctMoUnDevelop:
                    case ctMoDismantle:
                        break;
                    default://If it's not being built, or destroyed, take it
                        VFactory = NewVFactory;
                        Reinforce.TakeUnit(VFactory);
                        break;
                }
                    
            }
   	    }
    }



    //Find the strucfac 1 if it was rebuilt
    if(SFactory.IsLive() == 0)//If the handel is dead, then we need to find the new one
    {
IUnit NewSFactory;
    	InRectEnumerator Rectenum(MAP_RECT(67+31, 63-1, 70+31, 65-1));
    	//Search the area near the vecfac for a new one
   	    if(Rectenum.GetNext(NewSFactory) == 1)
   	    {
            if(NewSFactory.GetType() == mapStructureFactory)
            {
            	switch(NewSFactory.GetBusy())
                {
                    case ctMoDevelop:
                    case ctMoUnDevelop:
                    case ctMoDismantle:
                        break;
                    default://If it's not being built, or destroyed, take it
                        SFactory = NewSFactory;
                        Construction.TakeUnit(SFactory);
                        break;
                }
                    
            }
   	    }
    }





    //Find the strucfac 2 if it was rebuilt
    if(SFactory2.IsLive() == 0)//If the handel is dead, then we need to find the new one
    {
IUnit NewSFactory2;
    	InRectEnumerator Rectenum(MAP_RECT(62+31, 66-1, 65+31, 68-1));
    	//Search the area near the vecfac for a new one
   	    if(Rectenum.GetNext(NewSFactory2) == 1)
   	    {
            if(NewSFactory2.GetType() == mapStructureFactory)
            {
            	switch(NewSFactory2.GetBusy())
                {
                    case ctMoDevelop:
                    case ctMoUnDevelop:
                    case ctMoDismantle:
                        break;
                    default://If it's not being built, or destroyed, take it
                        SFactory2 = NewSFactory2;
                        Construction.TakeUnit(SFactory2);
                        break;
                }
                    
            }
   	    }
    }



   //Find common smelter if it was built
if(MiningGroupEstablished == 0)
{
   if(CommonOreSmelter.IsLive() == 0)
   {
IUnit NewCommonSmelter;
    InRectEnumerator Rectenum437(MAP_RECT(259-1, 178-1, 264-1, 182-1));
    //Search the area near the common smelter for a new one
       if(Rectenum437.GetNext(NewCommonSmelter) == 1)
       {
           if(NewCommonSmelter.GetType() == mapCommonOreSmelter)
           {
            switch(NewCommonSmelter.GetBusy())
               {
                   case ctMoDevelop:
                   case ctMoUnDevelop:
                   case ctMoDismantle:
                       break;
                   default://If it's not being built, or destroyed, take it
                       CommonOreSmelter = NewCommonSmelter;
                       break;
               }
                   
           }
       }
}
}

// Mine building test
   //Find common mine if it was built
if(MiningGroupEstablished == 0)
{
   if(CommonOreMine.IsLive() == 0)
   {
IUnit NewCommonMine;
    InRectEnumerator Rectenum439(MAP_RECT(60+31, 60-1, 62+31, 62-1));
    //Search the area near the common mine
       if(Rectenum439.GetNext(NewCommonMine) == 1)
       {
           if(NewCommonMine.GetType() == mapCommonOreMine)
           {
            switch(NewCommonMine.GetBusy())
               {
                   case ctMoDevelop:
                   case ctMoUnDevelop:
                   case ctMoDismantle:
                       break;
                   default://If it's not being built, or destroyed, take it
                       CommonOreMine = NewCommonMine;
                       break;
               }
                   
           }
       }
}
}

// Initialize mining group
if((MiningGroupEstablished == 0) && (CommonOreSmelter.IsLive() == 1) && (CommonOreMine.IsLive() == 1))
{
CommonMining.Setup(CommonOreMine, CommonOreSmelter, RareBox1);
CommonMining.SetTargCount(mapCargoTruck, mapNone, 3);
RebuildMines.TakeUnit(CommonOreMine);
MiningGroupEstablished = 1; // This will prevent the code from creating possible loops with odd results
}




}

SCRIPT_API void Repairallaibuildings()
{
Unit u;
PlayerBuildingEnum enum1(1, mapNone);
while (enum1.GetNext(u))
{
{
u.SetDamage(0);
}
}
}



// ---------- End of trigger functions ----------


// Note: This function is called by Outpost2.exe to obtain a description
//		 of a buffer that is saved to saved game files. Outpost2.exe
//		 calls this function and passes it a pointer to a structure
//		 which describes this buffer. This function is required to set
//		 the fields of this structure. If no buffer needs to be saved
//		 to a saved game file, then the buffer pointer needs to be set
//		 to 0, and the length should also be set to 0.
// Note: This function is called once when the DLL is first initialized.
//		 This means that all data to be saved must have space reserved
//		 ahead of time at the start of the level. (Static sized storage)
//		 In other words, there is no way to dynamically grow the size of
//		 the buffer if more space is needed than originally specified.
// Note: You can probably stretch the above limitation by saving the
//		 pointer to the buffer description passed by Outpost2.exe. This
//		 may allow you to increase the buffer size dynamically but the
//		 idea is yet untested. Keep in mind that you have no idea when
//		 a game may be saved (or just loaded). 

void __cdecl GetSaveRegions(struct BufferDesc &bufDesc)
{
	bufDesc.bufferStart = 0;	// Pointer to a buffer that needs to be saved
	bufDesc.length = 0;			// sizeof(buffer)
}





// Note: These last two functions aren't absolutely required by a level
//		 but they found in almost all DLLs anyways.


// Note: This export usually exists, but does nothing other than return 0.
//		 It's use may have been for checking for victory/failure conditions
//		 that are not easily checked for by using triggers.

int StatusProc()
{
	return 0; // must return 0
}


// Note: This is a trigger callback function. This function is
//		 intentionally left empty and is used as the trigger
//		 callback function for triggers that don't want or need
//		 any special callback function.
// Note: The use of SCRIPT_API is used by all trigger functions
//		 to ensure they are exported correctly. (Although, 
//		 technically it's not needed in this case since this
//		 function has a function prototype defined in 
//		 RequiredExports.h which contains the SCRIPT_API macro
//		 in it. However, most other trigger callback functions
//		 won't have a function prototype anywhere (and you really
//		 don't need to declare a function prototype since you
//		 should never be calling a callback function yourself)
//		 so you should use the SCRIPT_API macro when you define
//		 the function.
//		 Might as well set a good example. =)

SCRIPT_API void NoResponseToTrigger()
{
}


